/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XulApp IDE.
 *
 * The Initial Developer of the Original Code is Synesis Software (USA) Inc.
 *

 * Portions created by the Initial Developer are Copyright (C) 2001-2005
 * Synesis Software (USA) Inc. the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 	Peter Wilson, orignal author.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 *
 * ***** END LICENSE BLOCK ***** */
XaLib.include("chrome://xalib/content/XPCOM/XPCOM.js");
XaLib.include("chrome://xalib/content/IO/File/FileIO.js");
function DOMLoader
(

)

{
}

DOMLoader.load = function
// Load a DOM document synchronously from a URI.
(
	loadMimeType, 	// string: Mime type.
	URI,			// string: URI of document source.
	dropWhitespace	// boolean: drop inessential whitespace text nodes.
	// returns object: DOM document.
)
{
	var xml = File.readAll(URI);
	var domParser = XPCOM.getComponent("@mozilla.org/xmlextras/domparser;1", "nsIDOMParser");
	var dom =  domParser.parseFromString(xml, loadMimeType)
	//debug(dom);
	if (Components.lastResult != Components.results.NS_OK) 
		throw "XML parseFromString failed internally for " + URI; // internal failure.
	else {
		var documentElement = dom.documentElement;
		if (documentElement && documentElement.localName == "PARSERERROR") {
			var s = new XMLSerializer();
			var str = s.serializeToString(dom);
			throw "Parse error: " + URI + Utility.NEWLINE + str;
		}
	}		
	if (dropWhitespace)
		DOMLoader.dropWhitespace(dom.documentElement, true);
	return dom; 
}
/**
	load a DOM document asynchronously from a URI.
	@param uri the uri to open.
	@param namsepaceURI the namespace uri of the created document.
	@param onloadCallback a function to call when the document is loaded.
	@return the DOM document.
**/
DOMLoader.loadAsync = function(loadMimeType, uri, namespaceURI, onloadCallback) {
    var xmlDoc = document.implementation.createDocument(namespaceURI, "", null); 
    xmlDoc.addEventListener("load", onloadCallback, false); 
    xmlDoc.addEventListener("abort", onloadCallback, false); 
    xmlDoc.addEventListener("error", onloadCallback, false); 

    xmlDoc.load(uri, loadMimeType);
	 if (Components.lastResult != Components.results.NS_OK)  {
	 	alert(Components.lastResult);
	 }
	return xmlDoc;
}

DOMLoader.ISWS = /^\s*$/;
DOMLoader.dropWhitespace = function
(

	node, 	//DOMNode:
	drop	//boolean: drop = true
)//void:

{
	while (node) {
		var nextNode = node.nextSibling;;
		switch (node.nodeType) {
		case DOM.TEXT:
			if (drop && DOMLoader.ISWS.test(node.nodeValue))
				node.parentNode.removeChild(node);
			break;
		case DOM.ELEMENT:
			var childNode = node.firstChild;
			if (childNode) {
				var newDrop = drop;
				if (newDrop && node.getAttribute("xml:space") == "preserve")
					newDrop = false;
				DOMLoader.dropWhitespace(childNode, newDrop);
			}
		}
		node = nextNode;
	}
}


