/*** -*- Mode: Javascript; tab-width: 2;

The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is XulApp IDE.
The Initial Developer of the Original Code is Peter Wilson.

Portions created by Peter Wilson are
Copyright (C) 2000 Peter Wilson.  All
Rights Reserved.

************/

XaLib.include("chrome://xalib/content/IO/File/File.js");
File.dirURLToPath = function
(

	url	//string: dir://knownfolder/path...
		// Where known folder is one of;
		//ComsD:	 Folder that holds XPCOM components
		//CurProcD: Folder of the executable for the currently running process; always $MOZILLA_FIVE_HOME on UNIX
		//CurWorkD: Folder that is the present working directory of the current executable
		//DrvD:		Returns the top of the operating system's file system  Windows: usually C:; UNIX: /; Mac OS: the root volume
		//Home:		Home folder for the current user?Windows: %HOME%; UNIX: $HOME; Mac OS: the documents folder
		//TmpD:		Operating system location for temporary files?Windows: %TMP%; UNIX: $TMP; Mac OS: the temporary files folder
		//ProfD:	Directory of current profile.
		//+Other OS specific values.
)	//?string:

{
	try {
		if (!url.startsWith("dir://"))
			throw "File.dirURLtoPath: invalid url:" + url;
		url = url.substr(6);
		var i = url.indexOf("/");
		if (i < 1)
			throw "File.dirURLtoPath: invalid url:" + url;
		var aKey = url.substr(0, i);			
		// Provide more user friendly directory names.	
		
		var aKnownKey = File.KnownDirs[aKey];
		if (aKnownKey)
			aKey = aKnownKey;
		var localFile = File.DirectoryService.get(aKey, Components.interfaces.nsIFile);
		if (!localFile)
			null;
		var path = localFile.path + url.substr(i);
		if (File.pathSeparator == "\\") 
			path = path.replace(/\//g,"\\"); // Replace forward by retarded slashes.
		return path;
	}
	catch (e) { 
		throw "DirectoryService.dirURLToPath: Error: " + e + getStackTrace();
	}
}
// Initialize.
try {
	File.DirectoryService = XPCOM.getService("@mozilla.org/file/directory_service;1",
								  "nsIProperties");
	File.KnownDirs = {};
	File.KnownDirs.profile = "ProfD";
	File.KnownDirs.home = "Home";
	File.KnownDirs.temp = "TmpD";
}
catch (e) {
	"Directory Service failed to load.";
}


