/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XulApp IDE.
 *
 * The Initial Developer of the Original Code is Synesis Software (USA) Inc.
 *

 * Portions created by the Initial Developer are Copyright (C) 2001-2005
 * Synesis Software (USA) Inc. the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 	Peter Wilson, orignal author.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 *
 * ***** END LICENSE BLOCK ***** */
 
netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
XaLib.include("chrome://xalib/content/UI/Controls.js");
XaLib.include("chrome://xalib/content/IO/File/FileIO.js");
XaLib.include("chrome://xalib/content/Lexer/Tokenizer.js");
XaLib.include("chrome://xalib/content/FilePicker/FilePicker.js");

var controls;

const nsIThread = Components.interfaces.nsIThread;
const ThreadContractID = "@mozilla.org/thread;1";
const Thread = new Components.Constructor(ThreadContractID, "nsIThread", "init");
var parserThread = null;

var tokenizer;

function OnLoad() {
	controls = Controls.init();

//	lexDef = File.readAll("chrome://xalib/content/Lexer/LexDefs/javascript.lex");
	lexDef = File.readAll("chrome://xalib/content/Lexer/LexDefs/jsdoc.lex");
	if (lexDef)
		tokenizer = new Tokenizer(lexDef);
}

function cmdRegex(event) {
	var output = "";
	for (var stateName in tokenizer.states) {
		var state = tokenizer.states[stateName];
		output += "State:" + state.name + "\n";
		output += "Regex:" + state.regex.toSource() + "\n\n";
	}
	controls.txtOutput.value = output;
}

function cmdSelPath(event) {
	var filePicker = new FilePicker(window, "Test tokenizer.");
	filePicker.appendFilter("Javascript", "*.js");
	filePicker.appendFilter("All", "*.*");
	var result = filePicker.show();
	if (result == FilePicker.OK) {
		controls.txtPath.value = filePicker.file.path;
		loadInput();
	}
}

function loadInput() {
	var pathURI = File.pathToURL(controls.txtPath.value);
	controls.txtInput.value = File.readAll(pathURI);
}

function cmdParse(event) {
	if (!controls.txtInput.value)
		return;
	var output = "DONE\n";		
	
	tokenizer.init(controls.txtInput.value);
	
	var token = new Token();
	do {
		tokenizer.nextToken(token);
		output += "offset:" + token.offset + " type:" + token.type.name + ": " + token.val +  "\n";
	} while (token.type != tokenizer.EOF);
	controls.txtOutput.value = output;

}
