// An nsIRDFObserver object is an observer that will be notified
// when assertions are made or removed from a datasource

function DataSourceObserver() 
{
}

DataSourceObserver.prototype.onAssert = function
/* This method is called whenever a new assertion is made
 * in the data source
 */
(

	ds,			//nsIRDFDataSource: The datasource that is issuing the notification.
	subj,		//nsIRDFResource: The subject of the assertion
	pred,		//nsIRDFResource: The predicate of the assertion
	obj			//nsIRDFNode: The object of the assertion	
)

{
}

DataSourceObserver.prototype.onUnassert = function
/* This method is called whenever an assertion is removed
 * from the data source
 */
(

	ds,			//nsIRDFDataSource: The datasource that is issuing the notification.
	subj,		//nsIRDFResource: The subject of the assertion
	pred,		//nsIRDFResource: The predicate of the assertion
	obj			//nsIRDFNode: The object of the assertion	
)

{
}

DataSourceObserver.prototype.onChange = function
/* This method is called when the object of an assertion
 * changes from one value to another.
 */

(

	ds,			//nsIRDFDataSource: The datasource that is issuing the notification.
	subj,		//nsIRDFResource: The subject of the assertion
	pred,		//nsIRDFResource: The predicate of the assertion
	oldobj,		//nsIRDFNode: The old object of the assertion	
	newobj		//nsIRDFNode: The new object of the assertion	
)

{
}

DataSourceObserver.prototype.onMove = function
/* This method is called when the subject of an assertion
 * changes from one value to another.
 */
(

	ds,			//nsIRDFDataSource: The datasource that is issuing the notification.
	oldsubj,	//nsIRDFResource: The old subject of the assertion
	newsubj,	//nsIRDFResource: The new subject of the assertion
	pred,		//nsIRDFResource: The predicate of the assertion
	obj			//nsIRDFNode:	  The object of the assertion	
)

{
}

DataSourceObserver.prototype.onBeginUpdateBatch = function
/**
 * This method is called when a datasource is about to
 * send several notifications at once. The observer can
 * use this as a cue to optimize its behavior. The observer
 * can expect the datasource to call endUpdateBatch() when
 * the group of notifications has completed.
 * @param aDataSource the datasource that is going to
 *   be issuing the notifications.
 */
(

	aDataSource
)
{
}

DataSourceObserver.prototype.onEndUpdateBatch = function
/**
 * This method is called when a datasource has completed
 * issuing a notification group.
 * @param aDataSource the datasource that has finished
 *   issuing a group of notifications
 */
(

	aDataSource
)
{
}

