/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XulApp IDE.
 *
 * The Initial Developer of the Original Code is Synesis Software (USA) Inc.
 *

 * Portions created by the Initial Developer are Copyright (C) 2001-2005
 * Synesis Software (USA) Inc. the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 	Peter Wilson, orignal author.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 *
 * ***** END LICENSE BLOCK ***** */
netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
XaLib.include("chrome://xalib/content/XPCOM/XPCOM.js");

const NS_RDF_NO_VALUE           = 0xa0002;
const NS_RDF_ASSERTION_REJECTED = 0xa0003;

function DataSourceWrapper(innerDS, URI)
{
  this._innerDS = innerDS;
  this.URI = URI;
}

DataSourceWrapper.prototype.GetSource = function(pred, obj, tv) {
	 return this._innerDS.GetSource(pred, obj, tv);
}

DataSourceWrapper.prototype.GetSources = function(pred, obj, tv) {
	 return this._innerDS.GetSources(pred, obj, tv);
}

DataSourceWrapper.prototype.GetTarget = function(subj, pred, tv) {
	 return this._innerDS.GetTarget(subj, pred, tv);
}

DataSourceWrapper.prototype.GetTargets = function(subj, pred, tv) {
	 return this._innerDS.GetTargets(subj, pred, tv);
}

DataSourceWrapper.prototype.Assert = function(subj, pred, obj, tv) {
	this._innerDS.Assert(subj, pred, obj, tv);
}

DataSourceWrapper.prototype.Unassert = function(subj, pred, obj, tv) {
	this._innerDS.Unassert(subj, pred, obj, tv);
}

DataSourceWrapper.prototype.Change = function(subj, pred, oldobj, newobj) {
	this._innerDS.Change(subj, pred, oldobj, newobj);
}

DataSourceWrapper.prototype.Move = function(oldsubj, newsubj, pred, obj)  {
	this._innerDS.Move(oldsubj, newsubj, pred, obj);
}

DataSourceWrapper.prototype.HasAssertion = function(subj, pred, obj, tv) {
	return this._innerDS.HasAssertion(subj, pred, obj, tv);
}

DataSourceWrapper.prototype.AddObserver = function(aObserver) {
	 this._innerDS.AddObserver(aObserver);
}

DataSourceWrapper.prototype.RemoveObserver = function(aObserver) {
	this._innerDS.RemoveObserver(aObserver);
}

DataSourceWrapper.prototype.ArcLabelsIn = function(obj) {
	return this._innerDS.ArcLabelsIn(obj);
}

DataSourceWrapper.prototype.ArcLabelsOut = function(subj) {
	return this._innerDS.ArcLabelsOut(obj);
}

DataSourceWrapper.prototype.GetAllResources = function() {
	return this._innerDS.GetAllResources();
}

DataSourceWrapper.prototype.hasArcIn = function(obj, pred) {
	return this._innerDS.hasArcIn(obj, pred);
}

DataSourceWrapper.prototype.hasArcOut = function(subj, pred) {
	return this._innerDS.hasArcOut(subj, pred);
}


